/*
 File: prt_sr_elements.h
 Date and Time: Fri Jan 30 18:55:20 2015 
*/
#ifndef __prt_sr_elements_h__
#define __prt_sr_elements_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "o2_externs.h"
extern void XLATE_SYMBOLS_FOR_cweave(const char* Sym_to_xlate,char* Xlated_sym);
  
// monolithic grammar: no thread
extern yacco2::State S1_Cprt_sr_elements;
namespace NS_prt_sr_elements {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[5];
};
class Cprt_sr_elements: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rprt_sr_elements_ = 569//start_of_rule_list + 0
    ,rhs1_Rprt_sr_elements_ = 1
   ,R_Rsubrule_ = 570//start_of_rule_list + 2
    ,rhs1_Rsubrule_ = 2
   ,R_Rsubrule_def_ = 571//start_of_rule_list + 4
    ,rhs1_Rsubrule_def_ = 3
   ,R_Relements_ = 572//start_of_rule_list + 6
    ,rhs1_Relements_ = 4
    ,rhs2_Relements_ = 5
   ,R_Relement_ = 573//start_of_rule_list + 8
    ,rhs1_Relement_ = 6
    ,rhs2_Relement_ = 7
    ,rhs3_Relement_ = 8
    ,rhs4_Relement_ = 9
    ,rhs5_Relement_ = 10
    ,rhs6_Relement_ = 11
  };
  //no of la sets = 4
  //no of states = 16
  Cprt_sr_elements();
  ~Cprt_sr_elements();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[12];
  
    public:
      char big_buf_[BIG_BUFFER_32K];		
      std::ofstream* ow_index_file_;
      int elem_no_;
  
 };
struct Rprt_sr_elements;
struct Rsubrule;
struct Rsubrule_def;
struct Relements;
struct Relement;
struct Rprt_sr_elements:public yacco2::CAbs_lr1_sym {
  Rprt_sr_elements(yacco2::Parser* P);
  public:
};

struct Rsubrule:public yacco2::CAbs_lr1_sym {
  Rsubrule(yacco2::Parser* P);
  public:
};

struct Rsubrule_def:public yacco2::CAbs_lr1_sym {
  Rsubrule_def(yacco2::Parser* P);
  public:
  void sr1();
};

struct Relements:public yacco2::CAbs_lr1_sym {
  Relements(yacco2::Parser* P);
  public:
};

struct Relement:public yacco2::CAbs_lr1_sym {
  Relement(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
};

} // end of namespace

#endif
